

points = list()
masks = list()
lines = list()
masksVertices = set()
vertices=list()


def twoPointsOnLine(line):
    a, b, c = line[0], line[1], line[2]
    if a == 0:
        return (0, -c/b), (5, -c/b)
    elif b == 0:
        return (-c/a, 0), (-c/a, 5)
    else:
        return (0, -c/b), (1, (-c-a)/b)


def onLeft(pt, line):
    p1, p2 = twoPointsOnLine(line)
    v = p2[0] - p1[0], p2[1] - p1[1]
    v_pt = pt[0] - p1[0], pt[1] - p1[1]
    return v[0] * v_pt[1] - v[1] * v_pt[0] > 0


def PrimAlgorithm(vertices):
    N = len(vertices)  # number of vertices = number of different bitmasks
    res = 0
    used = [False for i in range(N)]
    minEdgeWeight = [100 for i in range(N)]
    minEdgeWeight[0] = 0

    for i in range(N):  # MST will contain N vertices
        # choose a vertex v which is not yet included in MST and has the minimum edge weight
        minEdge = 100
        v_idx = -1
        for i in range(N):
            if not used[i] and minEdgeWeight[i] < minEdge:
                minEdge = minEdgeWeight[i]
                v_idx = i
        used[v_idx] = True
        res += minEdge

        for u_idx in range(N):
            # consider edge vu
            u = vertices[u_idx]
            v = vertices[v_idx]
            minEdgeWeight[u_idx] = min(minEdgeWeight[u_idx], bin(u ^ v).count("1"))
    return res


n = int(input())
for i in range(n):
    x, y = input().split()
    points.append([int(x), int(y)])

m = int(input())
for i in range(m):
    a, b, c = input().split()
    lines.append([int(a), int(b), int(c)])

for p in points:
    mask = 0
    cnt = 0
    for line in lines:
        if onLeft(p, line):
            mask |= (1 << cnt)
        cnt += 1
    masksVertices.add(mask)

for v in masksVertices:
    vertices.append(v)

res = PrimAlgorithm(vertices)
print(res)
